﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private ws As WebSocket
	Private timer1 As Timer
	Private const API_KEY As String = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
End Sub

Public Sub Initialize
	
End Sub

Sub JobDone(job As HttpJob)
	Log(job)
	If job.Success Then
		Log(job.GetString)
	End If
	job.Release
End Sub

Private Sub SendMessagToUser(id As String, Message As String, PmsenderId As String)
	   	Dim Job As HttpJob
	   Job.Initialize("FCCM", Me)
	   Dim m As Map = CreateMap("to": $"${id}"$)
	   Dim data As Map = CreateMap("body": Message, "pmsenderid": PmsenderId )
	   m.Put("data": data)
	   Dim jg As JSONGenerator
	   jg.Initialize(m)
	   Log(jg.ToPrettyString(2))
	   Job.PostString("https://fcm.googleapis.com/fcm/send", jg.ToString)
	   Job.GetRequest.SetContentType("application/json;charset=UTF-8")
	   Job.GetRequest.SetHeader("Authorization", "key=" & API_KEY)
End Sub

Sub Pm_Message(Params As Map)
	SendMessagToUser(Params.Get("userreceivertoken"),Params.Get("message") , Params.Get("senderid"))
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Log(ws.Session.Id &" Connected")
	timer1.Initialize("timer1", 1000)
	timer1.Enabled = True
End Sub

Sub Timer1_Tick
	ws.RunFunction("ServerTime", Array As Object(DateTime.Time(DateTime.Now)))
	ws.Flush
End Sub

Sub Device_Message(Params As Map)
	Log("Device message: " & Params.Get("message"))
	ws.RunFunction("ServerResponse", Array As String( Params.Get("Token")))
	ws.Flush
	
End Sub

Private Sub WebSocket_Disconnected
	timer1.Enabled = False
	Log(ws.Session.Id & " Disconnected")
End Sub